//  Copyright (C) 2012  Stephen Compall
// 
//    Licensed under the Apache License, Version 2.0 (the "License");
//    you may not use this file except in compliance with the License.
//    You may obtain a copy of the License at
// 
//        http://www.apache.org/licenses/LICENSE-2.0
// 
//    Unless required by applicable law or agreed to in writing, software
//    distributed under the License is distributed on an "AS IS" BASIS,
//    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//    See the License for the specific language governing permissions and
//    limitations under the License.

namespace Nocandy.LinqResources.FS.ReaderVExample.Test

open NUnit.Framework
open Nocandy.LinqResources.FS.ReaderVExample

module u =
    let mFromSeq (xs: ('k * 'v) seq) = new Map<'k, 'v>(xs)

[<TestFixture()>]
type TestReaderVExample() =
    [<Test()>]
    member v.disabledRun (): unit =
        Assert.AreEqual(
            "ERROR: you must set runnable=yes",
            Scaffold.run("John", 33, u.mFromSeq([("runnable", "no")])))

    [<Test()>]
    member v.verboseRun (): unit =
        Assert.AreEqual(
            "The user Paul is of age 34",
            Scaffold.run("Paul", 34, u.mFromSeq([("runnable", "yes");
                                                 ("verbose", "yes")])))

    [<Test()>]
    member v.quietRun (): unit =
        Assert.AreEqual(
            "George is 33",
            Scaffold.run("George", 33, u.mFromSeq([("runnable", "yes");
                                                   ("verbose", "no")])))
